<script setup lang="ts">
import { automationsStore } from "../../stores/automations"

import { autoApiCall } from "../../api/automationsApi"

const router = useRouter()
const store = automationsStore()

const search = ref("")
const message = ref("")
const error = ref("")
const isOpen = ref(false)
const loading = ref(false)
const automations = computed(() =>
  Object.values(store.automations).filter((card: any) =>
    card?.name?.toLowerCase().includes(search.value),
  ),
)

function deleteAutomation(id: string, event: MouseEvent) {
  store.deleteAutomation(id)
  event.stopPropagation()
}
async function runAutomation(id: string, event: MouseEvent) {
  event.stopPropagation()
  const actions = store.automations[id].process.filter(
    (item: any) => item.type === "action",
  )

  loading.value = true
  if (
    actions.reduce((acc, value) => acc || value.actionType === "apiCall", false)
  )
    isOpen.value = true

  const promises: any[] = actions
    .filter((action: any) => action.actionType === "apiCall")
    .map((action) => {
      const { url, parameters } = action?.options || {}
      return autoApiCall(url, parameters)
    })
  const results = await Promise.all(promises)
  message.value = results.map((result: { data: string }) => result.data || "").join(" ")
  error.value = results.map((result: { errorMsg: string }) => result.errorMsg || "").join(" ")

  loading.value = false
}
function hasTrigger(id: string) {
  return store.automations[id].process.reduce(
    (acc, value) => acc || value.type === "trigger",
    false,
  )
}

const goToAutomation = (id: string) => {
  router.push({
    name: "automations-id",
    params: {
      id,
    },
  })
}
</script>

<template>
  <div class="flex flex-1 flex-col bg-white">
    <div
      class="sticky z-10 top-0 flex flex-row justify-between items-center p-4 md:p-6 border-b bg-[#FFF] border-[#E6E6E5]"
    >
      <h2 class="text-xl text-[#272726]">
        {{ $t("automations") }}
      </h2>
      <div class="flex items-center h-full text-sm">
        <button class="bbx-btn-primary">
          <div
            class="inline-block mr-1"
            i="carbon-add-alt"
            @click="goToAutomation('new')"
          />
          {{ $t("new") }}
        </button>
      </div>
    </div>

    <div class="flex flex-col p-4 gap-4 w-full">
      <div class="flex flex-row justify-between items-center gap-4">
        <div class="relative flex items-center w-full text-[#262626]">
          <div i="carbon-search" class="absolute w-4 left-3" />
          <input
            v-model="search"
            placeholder="Rechercher"
            type="text"
            class="flex w-full items-center gap-2 py-1 lg:py-2 pl-8 pr-4 text-sm border rounded transition cursor-pointer hover:border-[#3A8054] border-[#E6E6E]"
          >
        </div>
      </div>
      <div
        class="grid grid-cols-1 sm:grid-cols-2 lg:grid-cols-3 2xl:grid-cols-4 gap-4"
      >
        <div
          v-for="card in automations"
          :key="card.id"
          class="flex flex-col p-6 bg-[#FFF] border border-[#E6E6E5] rounded-md cursor-pointer"
          :tooltip="card.name"
          @click="goToAutomation(card.id)"
        >
          <div class="flex items-center">
            <div class="p-2 mr-2 bg-[#F1E7FE] text-[#650DD9]">
              <div i="carbon-bot" />
            </div>
            <div class="text-[#19181E] text-sm font-semibold truncate">
              {{ card.name }}
            </div>
            <div class="ml-auto">
              <button
                v-if="hasTrigger(card.id)"
                class="ml-auto mr-1 text-green border border-green rounded p-2"
                @click="(event) => runAutomation(card.id, event)"
              >
                Run
              </button>
              <button
                class="text-red border border-red rounded p-2"
                @click="(event) => deleteAutomation(card.id, event)"
              >
                X
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div
      v-if="isOpen"
      class="fixed top-50 left-50 right-0 z-50 p-4 md:inset-0 h-[calc(100%-1rem)] max-h-full"
    >
      <div class="relative w-full max-w-md max-h-full">
        <div class="relative bg-white rounded-lg shadow dark:bg-gray-700">
          <button
            type="button"
            class="absolute top-3 right-2.5 text-gray-400 bg-transparent hover:bg-gray-200 hover:text-gray-900 rounded-lg text-sm w-8 h-8 ml-auto inline-flex justify-center items-center dark:hover:bg-gray-600 dark:hover:text-white"
            @click="isOpen = false"
          >
            <svg
              class="w-3 h-3"
              aria-hidden="true"
              xmlns="http://www.w3.org/2000/svg"
              fill="none"
              viewBox="0 0 14 14"
            >
              <path
                stroke="currentColor"
                stroke-linecap="round"
                stroke-linejoin="round"
                stroke-width="2"
                d="m1 1 6 6m0 0 6 6M7 7l6-6M7 7l-6 6"
              />
            </svg>
            <span class="sr-only">Close modal</span>
          </button>
          <div class="p-6 text-center">
            <h1>Automation</h1>
            <h3
              v-if="loading"
              class="my-5 text-lg font-normal text-gray-500 dark:text-gray-400"
            >
              Loading...
            </h3>
            <div v-else />
            <h3
              class="my-5 text-lg font-normal text-gray-500 dark:text-gray-400"
            >
              {{ message }}
            </h3>
            <h3 class="my-5 text-lg font-normal text-red dark:text-gray-400">
              {{ error }}
            </h3>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<route lang="yaml">
meta:
  layout: home
</route>
